Add Rectangle Annotations via Text Search in Angular PDF Viewer

11 Feb 20264 minutes to read

A concise guide that demonstrates how to add rectangle annotations at highlighted text search results in the Angular PDF Viewer. The guide explains where to wire the callback, required services, and quick troubleshooting steps.

Steps to add rectangle annotations on search result highlight

Step 1: Follow the steps provided in the link to create a simple PDF Viewer sample in Angular.

Step 2: Set up the PDF Viewer component to add rectangle annotations based on the bounds of highlighted search text in the PDF Viewer.

import { Component, OnInit} from '@angular/core';
import {
  LinkAnnotationService,
  BookmarkViewService,
  MagnificationService,
  ThumbnailViewService,
  ToolbarService,
  NavigationService,
  AnnotationService,
  TextSearchService,
  TextSelectionService,
  FormFieldsService,
  FormDesignerService,
  PrintService
} from '@syncfusion/ej2-angular-pdfviewer';

@Component({
  selector: 'app-root',
  template: `
    <div class="content-wrapper">
      <div style="margin-top: 20px;">
       <!-- Search control buttons -->
        <button (click)="handleSearch()">Search PDF</button>
        <button (click)="handleSearchNext()">Search Next</button>
        <button (click)="handleCancelSearch()">Cancel Search</button>
      </div>
      <ejs-pdfviewer #pdfViewer
            id="pdfViewer"
            [documentPath]='document'
            [resourceUrl]='resource'
            style="height:640px;display:block"
            (textSearchHighlight)="handleTextSearchHighlight($event)">
  </ejs-pdfviewer>
    </div>
  `,
  providers: [
    LinkAnnotationService,
    BookmarkViewService,
    MagnificationService,
    ThumbnailViewService,
    ToolbarService,
    NavigationService,
    AnnotationService,
    TextSearchService,
    TextSelectionService,
    FormFieldsService,
    FormDesignerService,
    PrintService
  ]
})
export class AppComponent implements OnInit {
  public document: string = 'https://cdn.syncfusion.com/content/pdf/pdf-succinctly.pdf';
  public resource: string = 'https://cdn.syncfusion.com/ej2/28.1.33/dist/ej2-pdfviewer-lib';
  pdfViewerComponent: any;

  ngOnInit(): void {
  }

  //handles the search operation for the term 'PDF'
  handleSearch() {
    var pdfviewer = (<any>document.getElementById("pdfViewer")).ej2_instances[0];
    pdfviewer.textSearchModule.searchText('PDF', false);
  }

  //proceeds to the next search result
  handleSearchNext() {
    var pdfviewer = (<any>document.getElementById("pdfViewer")).ej2_instances[0];
    pdfviewer.textSearchModule.searchNext();
}

  //cancels the current search operation
  handleCancelSearch() {
    var pdfviewer = (<any>document.getElementById("pdfViewer")).ej2_instances[0];
    pdfviewer.textSearchModule.cancelTextSearch();
  }

  //Callback to add a rectangle annotation when search text is highlighted
  handleTextSearchHighlight(args: any) {
    var pdfviewer = (<any>document.getElementById("pdfViewer")).ej2_instances[0];
    console.log(args);
    const bounds = args.bounds;
    pdfviewer.annotationModule.addAnnotation('Rectangle', {
      pageNumber: args.pageNumber,
      offset: { x: bounds.left, y: bounds.top },
      width: bounds.width,
      height: bounds.height,
    });
  }
}

Following this guide enables the PDF Viewer to add rectangle annotations at text search result locations, improving visibility for users navigating search matches.

View sample in GitHub

Create Annotations from PDF Text Search Results

15 Jul 202611 minutes to read

A concise guide that demonstrates how to add rectangle and highlight annotations to text matched by a search in the Syncfusion React PDF Viewer. The guide explains where to wire the callback and the required services.

Prerequisites

A React PDF Viewer setup with Annotation module injected.

Steps to add rectangle or highlight annotations on search result highlight

Step 1: Follow the steps provided in the Syncfusion® Getting Started Guide to set up a basic PDF Viewer sample.

Step 2a: Add a rectangle annotation based on the bounds of each highlighted search match.

import { RefObject, useRef } from 'react';
import {
    PdfViewerComponent, Toolbar, Magnification, Navigation, Annotation, TextSelection,
    TextSearch, FormFields, FormDesigner, PageOrganizer, Print, Inject, RectangleSettings,
    TextSearchHighlightEventArgs, RectangleBoundsModel
} from '@syncfusion/ej2-react-pdfviewer';

export default function App() {
    const viewerRef: RefObject<PdfViewerComponent> = useRef(null);

    // Method to handle the text search highlight event
    const handleTextSearchHighlight = (args: TextSearchHighlightEventArgs) => {
        console.log(args); // Logs Highlighted text search details

        const pageNumber: number = args.pageNumber;
        const bounds: RectangleBoundsModel = args.bounds;

        // Add a rectangle annotation on the highlighted text
        viewerRef.current.annotationModule.addAnnotation('Rectangle', {
            pageNumber: pageNumber,
            offset: { x: bounds.left, y: bounds.top },
            width: bounds.width,
            height: bounds.height,
        } as RectangleSettings);
    };

    // Method to initiate a text search for the term 'PDF'
    const handleSearch = () => {
        viewerRef.current.textSearchModule.searchText('PDF', false);
    };

    // Method to go to the next instance of the search term
    const handleSearchNext = () => {
        viewerRef.current.textSearchModule.searchNext();
    };

    // Method to cancel the current text search operation
    const handleCancelSearch = () => {
        viewerRef.current.textSearchModule.cancelTextSearch();
    };

    return (
        <div>
            <div style={{ marginTop: '50px' }}>
                <button onClick={handleSearch}>Search PDF</button>
                <button onClick={handleSearchNext}>Search Next</button>
                <button onClick={handleCancelSearch}>Cancel Search</button>
            </div>
            <div className='control-section' style={{ marginTop: '5px' }}>
                <PdfViewerComponent
                    ref={viewerRef}
                    id="PdfViewer"
                    textSearchHighlight={handleTextSearchHighlight}
                    documentPath="https://cdn.syncfusion.com/content/pdf/pdf-succinctly.pdf"
                    resourceUrl="https://cdn.syncfusion.com/ej2/31.2.2/dist/ej2-pdfviewer-lib"
                    style={{ height: '640px' }}
                >
                    <Inject services={[
                        Toolbar, Magnification, Navigation, Annotation, TextSelection, TextSearch,
                        FormFields, FormDesigner, PageOrganizer, Print 
                    ]} />
                </PdfViewerComponent>
            </div>
        </div>
    );
}

Expected result: Rectangle annotations are added at text search result locations, improving visibility for users navigating search matches.

Step 2b: Add a highlight annotation based on the bounds of each highlighted search match.

import { RefObject, useRef } from 'react';
import {
    PdfViewerComponent, Toolbar, Magnification, Navigation, Annotation, TextSelection,
    TextSearch, FormFields, FormDesigner, PageOrganizer, Print, Inject, TextSearchHighlightEventArgs,
    HighlightSettings, IAnnotationPoint
} from '@syncfusion/ej2-react-pdfviewer';

export default function App() {
    const viewerRef: RefObject<PdfViewerComponent> = useRef(null);

    // Method to handle the text search highlight event
    const handleTextSearchHighlight = (args: TextSearchHighlightEventArgs) => {
        console.log(args); // Logs Highlighted text search details

        const pageNumber: number = args.pageNumber;
        const bounds: IAnnotationPoint[] = [{
            x: args.bounds.x ?? args.bounds.left,
            y: args.bounds.y ?? args.bounds.top,
            height: args.bounds.height,
            width: args.bounds.width
        }];

        // Add a highlight annotation on the highlighted text
        viewerRef.current.annotation.addAnnotation('Highlight', {
            pageNumber: pageNumber,
            bounds: bounds
        } as HighlightSettings);
    };

    // Method to initiate a text search for the term 'PDF'
    const handleSearch = () => {
        viewerRef.current.textSearchModule.searchText('PDF', false);
    };

    // Method to go to the next instance of the search term
    const handleSearchNext = () => {
        viewerRef.current.textSearchModule.searchNext();
    };

    // Method to cancel the current text search operation
    const handleCancelSearch = () => {
        viewerRef.current.textSearchModule.cancelTextSearch();
    };

    return (
        <div>
            <div style={{ marginTop: '50px' }}>
                <button onClick={handleSearch}>Search PDF</button>
                <button onClick={handleSearchNext}>Search Next</button>
                <button onClick={handleCancelSearch}>Cancel Search</button>
            </div>
            <div className='control-section' style={{ marginTop: '5px' }}>
                <PdfViewerComponent
                    ref={viewerRef}
                    id="PdfViewer"
                    textSearchHighlight={handleTextSearchHighlight}
                    documentPath="https://cdn.syncfusion.com/content/pdf/pdf-succinctly.pdf"
                    resourceUrl="https://cdn.syncfusion.com/ej2/31.2.2/dist/ej2-pdfviewer-lib"
                    style={{ height: '640px' }}
                >
                    <Inject services={[
                        Toolbar, Magnification, Navigation, Annotation, TextSelection, TextSearch,
                        FormFields, FormDesigner, PageOrganizer, Print 
                    ]} />
                </PdfViewerComponent>
            </div>
        </div>
    );
}

Expected result: Highlight annotation is added at text search result locations, improving visibility for users navigating search matches.

View sample the complete working sample on GitHub

Add rectangle annotations using text search bounds in Vue

28 Feb 20264 minutes to read

Overview

A concise guide that demonstrates how to add rectangle annotations at highlighted text search results in the Vue PDF Viewer. The guide explains where to wire the callback, required services, and quick troubleshooting steps.

Steps to add rectangle annotations on search result highlight

Step 1: Follow the steps provided in the Vue PDF Viewer Getting Started documentation to create a simple PDF Viewer sample.

Step 2: Set up the PDF Viewer component to add rectangle annotations based on the bounds of highlighted search text in the PDF Viewer.

<template>
  <div id="app">
    <!-- Buttons for search controls -->
    <div style="margin-top: 20px;">
      <button @click="handleSearch">Search PDF</button>
      <button @click="handleSearchNext">Search Next</button>
      <button @click="handleCancelSearch">Cancel Search</button>
    </div>
    <!-- PDF Viewer Component -->
      <ejs-pdfviewer
        id="pdfViewer"
        ref="pdfviewer"
        :documentPath="documentPath"
        :resourceUrl="resourceUrl"
        @textSearchHighlight="handleTextSearchHighlight"
    >
      </ejs-pdfviewer>
  </div>
</template>

<script>
import {
  PdfViewerComponent,
  Toolbar,
  Magnification,
  Navigation,
  LinkAnnotation,
  BookmarkView,
  Annotation,
  ThumbnailView,
  Print,
  TextSelection,
  TextSearch,
  FormFields,
  FormDesigner,
  PageOrganizer,
} from '@syncfusion/ej2-vue-pdfviewer';
export default {
  name: 'App',
  components: {
    'ejs-pdfviewer': PdfViewerComponent,
  },
  data() {
    return {
      resourceUrl: 'https://cdn.syncfusion.com/ej2/31.2.2/dist/ej2-pdfviewer-lib',
      documentPath: 'https://cdn.syncfusion.com/content/pdf/pdf-succinctly.pdf',
    };
  },
  provide: {
    // Inject necessary modules
    PdfViewer: [
      Toolbar,
      Magnification,
      Navigation,
      LinkAnnotation,
      BookmarkView,
      Annotation,
      ThumbnailView,
      Print,
      TextSelection,
      TextSearch,
      FormFields,
      FormDesigner,
      PageOrganizer,
    ],
  },
  methods: {
    // Method to initiate a text search for the term 'PDF'
    handleSearch() {
      this.$refs.pdfviewer.ej2Instances.textSearchModule.searchText('PDF', false);
    },
    // Method to go to the next instance of the search term
    handleSearchNext() {
      this.$refs.pdfviewer.ej2Instances.textSearchModule.searchNext();
    },
    // Method to cancel the current text search operation
    handleCancelSearch() {
      this.$refs.pdfviewer.ej2Instances.textSearchModule.cancelTextSearch();
    },
    // Method to handle the text search highlight event
    handleTextSearchHighlight(args) {
      console.log(args); // Log for debugging
      const bounds=args.bounds;
      // Add a rectangle annotation on the highlighted text
      this.$refs.pdfviewer.ej2Instances.annotationModule.addAnnotation('Rectangle', {
        pageNumber: args.pageNumber,
        offset: { x: bounds.left, y: bounds.top },
        width: bounds.width,
        height: bounds.height,
      });
    },
  },
};
</script>

Following this guide enables the PDF Viewer to add rectangle annotations at text search result locations, improving visibility for users navigating search matches.

View Sample on GitHub